<?php
// Cette librairie est base sur la librairie email.lib.php de PHP Final (http://phpfinal.guidewabmaster.net)

/* email.lib.php, 09/06/2002 22:01:05, Olivier BICHLER */

/* This librairy is based on libMailv3.0 from Nicolas VIVIEN - http://www.progweb.com/
 * Copyright (C) 2002 Nicolas VIVIEN
 *
 * Is was rewrited for PHP Final.
 *
 * Additionnals possible headers :
 * - Return-Path
 * - Delivered-To
 * - Content-Description
*/

class lib_email {
	var $charset = 'iso-8859-1';
	var $encoding = 'quoted-printable'; // base64, 7bit, 8bit, binary, quoted-printable
	var $mimeheader_encoding = 'Q'; // 'Q' = quoted-printable, 'B' = base64
	var $eol = "\n"; // Utilisez "\n" sur les systmes Unix et "\r\n" sous Windows

	var $headers = array();
	var $to = array();
	var $cc = array();
	var $bcc = array();
	var $receipt = FALSE;
	var $subject = '';
	var $body = array('text' => '', 'html' => '');
	var $attachment = array();
	var $_nb_inline = 0;
	var $_boundaries = array();
	var $_regexp_email = '[!#-\'\*\+\-0-9=\?A-Z\^-]+(\.[!#-\'\*\+\-0-9=\?A-Z\^-]+)*\@[a-z0-9\-]+(\.[a-z0-9\-]+)+';

	function lib_email() {
		$this -> _boundaries = array(
			md5(uniqid(time())),
			md5(uniqid(time())),
			md5(uniqid(time()))
		);
	}

	function from($address) {
		if ($address = $this -> _add_address($address)) {
			$this -> headers["From"] = $address;
			return TRUE;
		}

		return FALSE;
	}

	function to($address) {
		$bad_address = array();
		$new_address = array();

		if (!is_array($address)) {
			$tab_address = explode(",", $address);
		}

		foreach ($tab_address as $address) {
			if ($address = $this -> _add_address($address)) {
				$new_address[] = $address;
			}
			else {
				$bad_address[] = $address;
			}
		}

		$this -> to = array_merge($this -> to, $new_address);

		return $bad_address;
	}

	function replyto($address) {
		if ($address = $this -> _add_address($address)) {
			$this -> headers["Reply-To"] = $address;
			return TRUE;
		}

		return FALSE;
	}

	function cc($address) {
		$bad_address = array();
		$new_address = array();

		if (!is_array($address)) {
			$tab_address = explode(",", $address);
		}

		foreach ($tab_address as $address) {
			if ($address = $this -> _add_address($address)) {
				$new_address[] = $address;
			}
			else {
				$bad_address[] = $address;
			}
		}

		$this -> cc = array_merge($this -> cc, $new_address);

		return $bad_address;
	}

	function bcc($address) {
		$bad_address = array();
		$new_address = array();

		if (!is_array($address)) {
			$tab_address = explode(",", $address);
		}

		foreach ($tab_address as $address) {
			if ($address = $this -> _add_address($address)) {
				$new_address[] = $address;
			}
			else {
				$bad_address[] = $address;
			}
		}

		$this -> bcc = array_merge($this -> bcc, $new_address);

		return $bad_address;
	}

	function receipt($bool = TRUE) {
		$this -> receipt = (bool) $bool;
	}

	function priority($priority = 3) {
		$this -> headers["X-Priority"] = (int) $priority;
	}

	function add_header($header, $value, $encode = TRUE) {
		$this -> headers[$header] = $this -> _encode_mimeheader($value, $this -> charset, $this -> mimeheader_encoding);
	}

	function subject($subject) {
		$this -> subject = $this -> _encode_mimeheader($subject, $this -> charset, $this -> mimeheader_encoding);
	}

	function body($body, $format = "dual", $nl2br = FALSE) {
		if ($format == "dual") {
			$this -> body["text"].= strip_tags($body);
			$format = 'html';
		}
		if($format == 'html') {
			if ($nl2br) {
				$body = nl2br($body);
			}
		}
		$this -> body[$format].= $body;
	}

	function attach($filename, $name = '', $disposition = 'attachment', $type = 'application/octet-stream', $encoding = 'base64') {
		if (file_exists($filename)) {
			$name = (empty($name)) ? basename($filename) : $name;

			$this -> attachment[] = array(
				'name' => $name,
				'filename' => $filename,
				'filetype' => $type,
				'disposition' => $disposition,
				'encoding' => $encoding,
				'cid' => uniqid("", TRUE).'@PhpFinal'
			);

			if ($disposition == "inline") {
				$this -> _nb_inline++;
			}
			return TRUE;
		}
		else {
			return FALSE;
		}
	}

	function send($confirm = TRUE) {
		if (!empty($this -> headers["From"]) && count($this -> to) > 0 && !empty($this -> subject) && !empty($this -> body["text"])) {
			$this -> headers["Subject"] = $this -> subject;
			$this -> headers["To"] = implode(", ", $this -> to);
			$email = $this -> _make_email();
			if (!$confirm) {
    			return implode("", $email);
			}
			else {
				unset($this -> headers["To"]);
				unset($this -> headers["Subject"]);
				$email = $this -> _make_email();
				if (function_exists("mail")) {
					@mail(implode(", ", $this -> to), $this -> subject, $email["body"].$email["attachment"], $email["headers"]);
					Return 'ok';
				}
				elseif (function_exists("email")) {
					if (isset($this -> headers["Reply-To"]) && $this -> headers["Return-path"]) {
						email($this -> headers["From"], implode(", ", $this -> to), $this -> subject, $email["body"].$email["attachment"], $this -> headers["Reply-To"], $this -> headers["Return-path"]);
						Return 'ok';
					}
					elseif (isset($this -> headers["Reply-To"])) {
						email($this -> headers["From"], implode(", ", $this -> to), $this -> subject, $email["body"].$email["attachment"], $this -> headers["Reply-To"]);
						Return 'ok';
				}
					else {
						email($this -> headers["From"], implode(", ", $this -> to), $this -> subject, $email["body"].$email["attachment"]);
						Return 'ok';
					}
				}
				else {
					Return 'error';
				}
			}
		}
		else {
			if (empty($this -> headers["From"])) {
				Return 'noexp';
			}

			if (count($this -> to) == 0) {
				$ret .= 'nodest';
			}

			if (empty($this -> subject)) {
				$ret .= 'nosuj';
			}

			if (empty($this -> body["text"])) {
				$ret .= 'nomess';
			}
			return FALSE;
		}
	}
	function _make_email() {
		$this -> _make_headers();
		$boundary = 0;
		$body = "";
		$headers = "";
		$attachment = "";
		$in_attachment = (count($this -> attachment) > 0 && $this -> _nb_inline < count($this -> attachment)) ? TRUE : FALSE;
		$in_inline = (count($this -> attachment) > 0 && $this -> _nb_inline > 0) ? TRUE : FALSE;
		if (empty($this -> body["html"])) {
			if ($in_inline) {
				$in_attachment = TRUE;
			}
			$in_inline = FALSE;
		}
		if ($in_attachment) {
			$this -> headers["Content-Type"] = "multipart/mixed; boundary=\"Boundary-=".$this -> _boundaries[$boundary]."\"";
			if ($in_inline) {
				$body.= $this -> eol;
				$body.= "--Boundary-=".$this -> _boundaries[$boundary++].$this -> eol;
				$body.= "Content-Type: multipart/related; boundary=\"Boundary-=".$this -> _boundaries[$boundary]."\"".$this -> eol;
				$body.= $this -> eol;
			}
		}
		elseif ($in_inline) {
			$this -> headers["Content-Type"] = "multipart/related; type=\"multipart/alternative\"; boundary=\"Boundary-=".$this -> _boundaries[$boundary]."\"";
		}
		if (!empty($this -> body["html"]) && ($in_inline || $in_attachment)) {
			$body.= $this -> eol;
			$body.= "--Boundary-=".$this -> _boundaries[$boundary++].$this -> eol;
			$body.= "Content-Type: multipart/alternative; boundary=\"Boundary-=".$this -> _boundaries[$boundary]."\"".$this -> eol;
			$body.= $this -> eol;
		}
		ksort($this -> headers);
		foreach ($this -> headers as $key => $value) {
			$headers.= $key.": ".$value.$this -> eol;
		}
		$body.= $this -> _make_body($boundary);
		if (!empty($this -> body["html"])) {
			$boundary--;
		}
		$attachment.= ($in_inline) ? $this -> _make_attachment("inline", $boundary--) : "";
		$attachment.= ($in_attachment) ? $this -> _make_attachment("attachment", $boundary) : "";
		return array(
			"headers" => $headers,
			"body" => $body,
			"attachment" => $attachment
		);
	}
	function _make_headers() {
		if (count($this -> cc) > 0) {
			$this -> headers["Cc"] = implode(", ", $this -> cc);
		}
		if (count($this -> bcc) > 0) {
			$this -> headers["Bcc"] = implode(", ", $this -> bcc);
		}
		if ($this -> receipt) {
			if (isset($this -> headers["Reply-To"])) {
				$this -> headers["Disposition-Notification-To"] = $this -> headers["Reply-To"];
			}
			else {
				$this -> headers["Disposition-Notification-To"] = $this -> headers["From"];
			}
		}
		if (!empty($this -> body["html"])) {
			$this -> headers["Content-Type"] = "multipart/alternative; boundary=\"Boundary-=".$this -> _boundaries[0]."\"";
		}
		else {
			$this -> headers["Content-Type"] = "text/plain; charset=\"".$this -> charset."\"";
			$this -> headers["Content-Transfer-Encoding"] = $this -> encoding;
		}
		$this -> headers["MIME-Version"] = "1.0";
		$this -> headers["X-Mailer"] = "PHP/".phpversion();
		$this -> headers["Date"] = gmdate("D, d M Y H:i:s +0000");
		$this -> headers["Message-Id"] = "<".uniqid("", TRUE)."@PhpFinal>";
	}
	function _make_body($boundary) {
		$html = $this -> body["html"];
		$text = $this -> body["text"];
		$buffer = "";
		if (!empty($this -> body["html"])) {
			$buffer.= $this -> eol;
			$buffer.= "--Boundary-=".$this -> _boundaries[$boundary].$this -> eol;
			$buffer.= "Content-Type: text/plain; charset=\"".$this -> charset."\"".$this -> eol;
			$buffer.= "Content-Transfer-Encoding: ".$this -> encoding.$this -> eol;
			$buffer.= $this -> eol;
			$buffer.= $this -> _encode_string($text, $this -> encoding).$this -> eol;
			$buffer.= $this -> eol;
			$buffer.= "--Boundary-=".$this -> _boundaries[$boundary].$this -> eol;
			$buffer.= "Content-Type: text/html; charset=\"".$this -> charset.$this -> eol;
			$buffer.= $this -> eol;
			for ($i = 0, $patterns = array(), $replacements = array(); $i < count($this -> attachment); $i++) {
				$html = preg_replace('/(<img src=")('.preg_quote(basename($this -> attachment[$i]["filename"]), '/').')(".*>)/si', '$1cid:'.$this -> attachment[$i]['cid'].'$3', $html);
			}
			$buffer.= $html.$this -> eol;
			$buffer.= $this -> eol;
			$buffer.= "--Boundary-=".$this -> _boundaries[$boundary]."--".$this -> eol;
		}
		else {
			if (count($this -> attachment) > 0) {
				$buffer.= $this -> eol;
				$buffer.= "--Boundary-=".$this -> _boundaries[$boundary].$this -> eol;
				$buffer.= "Content-Type: text/plain; charset=\"".$this -> charset."\"".$this -> eol;
				$buffer.= "Content-Transfer-Encoding: ".$this -> encoding.$this -> eol;
			}
			$buffer.= $this -> eol;
			$buffer.= $this -> _encode_string($text, $this -> encoding).$this -> eol;
			$buffer.= $this -> eol;
		}
		return $buffer;
	}
	function _make_attachment($dispo, $boundary) {
		for ($i = 0, $found = FALSE, $buffer = ""; $i < count($this -> attachment); $i++) {
			$basename = basename($this -> attachment[$i]["filename"]);
			$disposition = (!empty($this -> body["html"])) ? $this -> attachment[$i]["disposition"] : "attachment";
			if ($disposition == $dispo) {
				$found = TRUE;
				$buffer.= $this -> eol;
				$buffer.= "--Boundary-=".$this -> _boundaries[$boundary].$this -> eol;
				$buffer.= "Content-Disposition: ".$dispo."; filename=\"".$basename."\"".$this -> eol;
				if ($this -> attachment[$i]["disposition"] == "inline") {
					$buffer.= "Content-ID: <".$this -> attachment[$i]["cid"].">".$this -> eol;
				}
				$buffer.= "Content-Transfer-Encoding: ".$this -> attachment[$i]["encoding"].$this -> eol;
				$buffer.= "Content-Type: ".$this -> attachment[$i]["filetype"]."; name=\"".$this -> attachment[$i]["name"]."\"".$this -> eol.$this -> eol;
				$buffer.= $this -> _encode_file($this -> attachment[$i]["filename"], $this -> attachment[$i]["encoding"]);
				$buffer.= $this -> eol;
			}
		}
		if ($found) {
			$buffer.= "--Boundary-=".$this -> _boundaries[$boundary]."--".$this -> eol;
		}
		return $buffer;
    }
    function _encode_file($filename, $encoding = "base64") {
		if (file_exists($filename) && $file = @fopen($filename, "rb")) {
			$content = fread($file, filesize($filename));
			fclose($file);
			$encoded = $this -> _encode_string($content, $encoding);
			return $encoded;
		}
		return FALSE;
	}
	function _encode_string($str, $encoding = "base64") {
		switch (strtolower($encoding)) {
			case "base64":
				$encoded = chunk_split(base64_encode($str));
			break;
			case "7bit":
			case "8bit":
				$encoded = $this -> _fix_eol($str);
				if (substr($encoded, -strlen($this -> eol)) != $this -> eol) {
					$encoded.= $this -> eol;
				}
			break;
			case "binary":
				$encoded = $str;
			break;
			case "quoted-printable": // RFC 2045 (http://jlr31130.free.fr/rfc2045.html)
				$encoded = $this -> _fix_eol($str);
				if (substr($encoded, -strlen($this -> eol)) != $this -> eol) {
					$encoded.= $this -> eol;
				}
				if (function_exists("imap_8bit")) {
					$encoded = imap_8bit($str);
				}
				else {
					for ($i = 0, $encoded = '', $encoded_length = 0; $i < strlen($str); $i++) {
						$c = ord($str[$i]);
						$c_length = (($c >= 33 && $c <= 60) || ($c >= 62 && $c <= 126)) ? 1 : 3;
						$encoded_length+= $c_length;
						if ($encoded_length + 1 > 76 && $i < strlen($str)) {
							$encoded.= '='.$this -> eol;
							$encoded_length = $c_length;
						}
						$encoded.= (($c >= 33 && $c <= 60) || ($c >= 62 && $c <= 126)) ? chr($c) : sprintf("=%02X", $c);
					}
				}
			break;
			default:
				return 'enc';
		}
		return $encoded;
	}
	function _encode_mimeheader($str, $charset = 'us-ascii', $encoding = 'B') {
		if (function_exists('mb_encode_mimeheader')) {
			$encoded = mb_encode_mimeheader($str, $charset, $encoding, $this -> eol);
		}
		else {
			$start = '=?'.$charset.'?'.$encoding.'?';
			$end = '?=';
			$spacer = $end.$this -> eol.' '.$start;
			switch (strtoupper($encoding)) {
				case 'B':
					$length = 75 - (strlen($start) + strlen($end));
					$length = floor($length / 2) * 2;
					$str = base64_encode($str);
					$str = chunk_split($str, $length - 1, $spacer);
					$str = preg_replace('/'.preg_quote($spacer, '/').'$/', '', $str);
					$encoded = $start.$str.$end;
				break;
				case 'Q':
					// Quoted-printable, RFC 2047 (http://jlr31130.free.fr/rfc2047.html)
					$length = 75 - (strlen($start) + strlen($end));
					for ($i = 0, $encoded = '', $encoded_length = 0; $i < strlen($str); $i++) {
						$c = ord($str[$i]);
						if ($c == 32) {
							$c = ord('_');
							$space = TRUE;
						}
						else {
							$space = FALSE;
						}
						$c_length = ((($c >= 63 && $c <= 90) || ($c >= 95 && $c <= 122)) || $space) ? 1 : 3;
						$encoded_length+= $c_length;
						if ($encoded_length + 1 > $length && $i < strlen($str)) {
							$encoded.= $spacer;
							$encoded_length = $c_length;
						}
						$encoded.= ((($c >= 63 && $c <= 90) || ($c >= 95 && $c <= 122)) || $space) ? chr($c) : sprintf("=%02X", $c);
					}
					$encoded = $start.$encoded.$end;
				break;
				case FALSE:
					$encoded = $str;
				break;
				default:
					return 'enc';
			}
		}
    return $encoded;
	}
	function _fix_eol($str) {
		$str = str_replace("\r\n", "\n", $str);
		$str = str_replace("\r", "\n", $str);
		$str = str_replace("\n", $this -> eol, $str);
		return $str;
	}
	function _add_address($address) {
		$address = trim($address);
		if (!preg_match('/\A'.$this -> _regexp_email.'\z/i', $address)) {
			if (preg_match_all('/\A(.+)?[\s]+\<('.$this -> _regexp_email.')\>\z/i', $address, $regs)) {
				return $this -> _encode_mimeheader($regs[1][0], $this -> charset, $this -> mimeheader_encoding).' <'.$regs[2][0].'>';
			}
		}
		else {
			return $address;
		}
		return FALSE;
	}
}
?>