<?php
class IBDRapport {
    var $corps; // Corps du rapport
    var $titre; // Titre du rapport
    var $codeErreur; // Code erreur
    var $lang; // Variable de langue du rapport

    // Initialisation de la classe
    function IBDRapport($lang) {
        $this->corps = "";
        $this->titre = "";
        $this->codeErreur = 0;
        $this->lang = $lang;
    }

    // Gnration du rapport
    function construire($codeErreur = 0) {
        $this->corps = $this->lang["message_base"];
        if ($codeErreur != 0) {
            $tmpl = new IBDTemplate($this->lang["message_code"]);
            $tmpl->remplacerDirect("CODE_ERREUR", $codeErreur);
            $this->corps .= $tmpl->get();
            $tmpl->set($this->lang["message_titre_code"]);
            $tmpl->remplacerDirect("CODE_ERREUR", $codeErreur);
            $this->titre = $tmpl->get();
            $this->codeErreur = $codeErreur;
        }
        else {
            $this->titre = $this->lang["message_titre"];
        }
        $this->corps .= $this->lang["message_rapport_simple"];
        $this->corps .= " - Document demand : ".(isset($_SERVER["REQUEST_URI"]) ? $_SERVER["REQUEST_URI"] : "-")."\n";
        $this->corps .= " - Rfrant : ".(isset($_SERVER["HTTP_REFERER"]) ? $_SERVER["HTTP_REFERER"] : "-")."\n";
        $this->corps .= " - Navigateur : ".(isset($_SERVER["HTTP_USER_AGENT"]) ? $_SERVER["HTTP_USER_AGENT"] : "-")."\n";
        $this->corps .= " - Date/Heure : ".date("d/m/Y @ H:i:s",time());
      
    /*    $_SERVER;
        $_ENV;
        $_GET;
        $_POST;
        $_SESSION;
        $_COOKIE;*/
    }

    // Envoi du rapport par mail
    function envoyer($adresse, $confirm = true)
    {
        include("include/email.cls.php");
        $eml = new lib_email();
        $eml->to($adresse);
        $eml->from($adresse);
        $eml->subject($this->titre);
        $eml->body($this->corps, "dual", true);
        return $eml->send($confirm);
    }

    // Affichage du rapport au format texte ou HTML
    function get($format = "texte") {
        $ret = "<h1>".$this->titre."</h1>\n";
        $ret .= "<p>".nl2br($this->corps)."</p>";
        if ($format == "html") {
            return $ret;
        }
        else {
            return strip_tags($ret);
        }
    }
}
?>