<?php
require("include/defaut.inc.php");
require("include/config.inc.php");
require("include/lang/".$CONF["lang_mail"].".mail.php");
require("include/lang/".$CONF["lang_page"].".page.php");
require("include/rapport.cls.php");
require("include/template.cls.php");
require("include/lib.php");

/* Patch temporaire pour Google Webmaster Tools */
if (eregi("\/noexist_.*\.html", $_SERVER["REQUEST_URI"])) {
    die();
}
if (eregi("\/google.*\.html", $_SERVER["REQUEST_URI"])) {
    die();
}
/* Fin patch temporaire pour Google Webmaster Tools */

// Rcupration du code erreur (0 si inconnue)
$erreur = isset($ERREURS_CONNUES[$_SERVER["REDIRECT_STATUS"]]) ? $_SERVER["REDIRECT_STATUS"] : 0;
// Gnration du rapport
$rapport = new IBDRapport($MAIL);
$rapport->construire($erreur);
$tmpl = new IBDTemplate();

// Envoi du rapport

$envoi =    !uriExclue($_SERVER["REQUEST_URI"])
         && (isset($RAPPORT[$erreur]) ? $RAPPORT[$erreur] : $CONF["rapport"])
         && (isset($_SERVER["HTTP_REFERER"]) ? true : $CONF["rapport_sans_ref"]);
if ($envoi) {
    $destinataire = isset($MAILS[$erreur]) ? $MAILS[$erreur] : $CONF["mail"];
    if (adresseValide($destinataire)) {
        $res = $rapport->envoyer($destinataire, true);
        $envoi = ($res == "ok");
    }
    else {
        $res = "destinataire invalide";
        $envoi = false;
    }
    if (!$envoi) {
        echo("<!-- mail : ".$res." -->\n");
        echo("<!--\n");
        echo($res);
        echo("\n-->\n");
    }
}

// Redirection
$redir = isset($REDIRIGE[$erreur]) ? $REDIRIGE[$erreur] : $CONF["redirige"];
if ($redir) {
    // Liste des champs  remplacer dans l'URL de redirection
    $remplacement["LANG"]        = $CONF["lang_page"];
    $remplacement["CODE_ERREUR"] = $erreur;

    if (isset($REDIRECTION[$erreur])) {
        $tmpl->set($REDIRECTION[$erreur]);
        $tmpl->remplacerTableau($remplacement);
        $tmpl->remplacerTableau($_SERVER);
        header("Location: ".$tmpl->get());
        exit;
    }
    else if (isset($CONF["redirection"])) {
        $tmpl->set($CONF["redirection"]);
        $tmpl->remplacerTableau($remplacement);
        $tmpl->remplacerTableau($_SERVER);
        header("Location: ".$tmpl->get());
        exit;
    }
}

// Gnration de la page d'erreur
$tmpl->charge($erreur);

// Liste des champs  remplacer dans l'URL de redirection
$remplacement["PAGE_TITRE"]  = isset($PAGE_TITRE[$erreur]) ? $PAGE_TITRE[$erreur] : "";
$remplacement["PAGE_ERREUR"] = isset($PAGE_ERREUR[$erreur]) ? $PAGE_ERREUR[$erreur] : "";
$remplacement["PAGE_DESC"]   = isset($PAGE_DESC[$erreur]) ? $PAGE_DESC[$erreur] : "";
$remplacement["NOM_SITE"]    = $CONF["nom_site"];
$remplacement["URL_SITE"]    = $CONF["url_site"];
$remplacement["CODE_ERREUR"] = $erreur;
$tmpl->remplacerTableau($remplacement);
$tmpl->remplacerTableau($_SERVER);

// Suppression du message "L'admin a t prvenu" en cas d'chec de l'envoi du mail
if (!$envoi) {
    $PAGE_MESSAGES["ADMIN_PREVENU"] = "";
}
$tmpl->remplacerTableau($PAGE_MESSAGES); 

echo("<!--\n");
echo($rapport->get());
echo("\n-->\n");
echo($tmpl->get());
?>